=== Utilities/hdf5/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)
PROJECT(VTKHDF5 C)
INCLUDE_REGULAR_EXPRESSION("^.*\\.[ch]$")

# EXPORT() will be in cmake 2.6, add an empty macro so older cmake versions still work
IF(NOT COMMAND EXPORT)
  MACRO(EXPORT)
  ENDMACRO(EXPORT)
ENDIF(NOT COMMAND EXPORT)


SET(LIBRARY_OUTPUT_PATH ${VTKHDF5_BINARY_DIR}/bin CACHE PATH
  "Single output directory for building all libraries.")
SET(EXECUTABLE_OUTPUT_PATH ${VTKHDF5_BINARY_DIR}/bin CACHE PATH
  "Single output directory for building all executables.")
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

# Choose install directories.
IF(NOT VTKHDF5_INSTALL_LIB_DIR)
  SET(VTKHDF5_INSTALL_LIB_DIR /lib)
ENDIF(NOT VTKHDF5_INSTALL_LIB_DIR)

# Let parent project set VTKHDF5_INSTALL_NO_DEVELOPMENT or
# VTKHDF5_INSTALL_NO_RUNTIME to remove components from the installation.
SET(VTKHDF5_INSTALL_NO_LIBRARIES)
IF(BUILD_SHARED_LIBS)
  IF(VTKHDF5_INSTALL_NO_RUNTIME AND VTKHDF5_INSTALL_NO_DEVELOPMENT)
    SET(VTKHDF5_INSTALL_NO_LIBRARIES 1)
  ENDIF(VTKHDF5_INSTALL_NO_RUNTIME AND VTKHDF5_INSTALL_NO_DEVELOPMENT)
ELSE(BUILD_SHARED_LIBS)
  IF(VTKHDF5_INSTALL_NO_DEVELOPMENT)
    SET(VTKHDF5_INSTALL_NO_LIBRARIES 1)
  ENDIF(VTKHDF5_INSTALL_NO_DEVELOPMENT)
ENDIF(BUILD_SHARED_LIBS)

SET(CMAKE_C_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_C_FLAGS}")

IF(NOT HDF5_ZLIB_HEADER)
  SET(HDF5_ZLIB_HEADER "zlib.h")
ENDIF(NOT HDF5_ZLIB_HEADER)
CONFIGURE_FILE(${VTKHDF5_SOURCE_DIR}/hdf5_zlib.h.in
  ${VTKHDF5_BINARY_DIR}/hdf5_zlib.h)

# Block warnings unless we are instructed to allow them.
# SET(HDF5_WARNINGS_ALLOW 1)
IF(NOT HDF5_WARNINGS_ALLOW)
  # MSVC uses /w to suppress warnings.  It also complains if another
  # warning level is given, so remove it.
  IF(MSVC)
    SET(HDF5_WARNINGS_BLOCKED 1)
    STRING(REGEX REPLACE "(^| )([/-])W[0-9]( |$)" " "
      CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /w")
  ENDIF(MSVC)

  # Borland uses -w- to suppress warnings.
  IF(BORLAND)
    SET(HDF5_WARNINGS_BLOCKED 1)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w-")
  ENDIF(BORLAND)

  # Most compilers use -w to suppress warnings.
  IF(NOT HDF5_WARNINGS_BLOCKED)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w")
  ENDIF(NOT HDF5_WARNINGS_BLOCKED)
ENDIF(NOT HDF5_WARNINGS_ALLOW)

SET(PACKAGE_VERSION "\"1.6.5\"")
SET(PACKAGE_TARNAME "\"hdf5\"")
SET(PACKAGE_NAME "\"HDF5\"")
SET(PACKAGE_STRING "\"HDF5 1.6.5\"")
SET(PACKAGE_BUGREPORT "\"hdfhelp@ncsa.uiuc.edu\"")

SET(LINUX_LFS 0)
IF(CMAKE_SYSTEM MATCHES "Linux-([3-9]\\.[0-9]|2\\.[4-9])\\.")
  OPTION(HDF5_ENABLE_LINUX_LFS
    "Enable support for large (64-bit) files on Linux." ON)
  IF(HDF5_ENABLE_LINUX_LFS)
    SET(LINUX_LFS 1)
  ENDIF(HDF5_ENABLE_LINUX_LFS)
ENDIF(CMAKE_SYSTEM MATCHES "Linux-([3-9]\\.[0-9]|2\\.[4-9])\\.")
SET(HDF5_EXTRA_FLAGS)
IF(LINUX_LFS)
  SET(HDF5_EXTRA_FLAGS
    -D_FILE_OFFSET_BITS=64
    -D_LARGEFILE64_SOURCE
    -D_LARGEFILE_SOURCE)
ENDIF(LINUX_LFS)
ADD_DEFINITIONS(${HDF5_EXTRA_FLAGS})

OPTION(HDF5_STREAM_VFD "Compile Stream Virtual File Driver support" ON)
OPTION(HDF5_ENABLE_HSIZET "Enable datasets larger than memory" ON)
IF(VTK_USE_MPI)
  OPTION(HDF5_ENABLE_PARALLEL "Enable parallel build (uses MPI)" OFF)
ENDIF(VTK_USE_MPI)

# Include all the necessary files for macros
INCLUDE (CheckFunctionExists)
INCLUDE (CheckIncludeFile)
INCLUDE (CheckIncludeFileCXX)
INCLUDE (CheckIncludeFiles)
INCLUDE (CheckLibraryExists)
INCLUDE (CheckSymbolExists)
INCLUDE (CheckTypeSize)

# This macro checks if the symbol exists in the library and if it
# does, it appends library to the list.
SET(LINK_LIBS "")
MACRO(CHECK_LIBRARY_EXISTS_CONCAT LIBRARY SYMBOL VARIABLE)
  CHECK_LIBRARY_EXISTS("${LIBRARY};${LINK_LIBS}" ${SYMBOL} "" ${VARIABLE})
  IF(${VARIABLE})
    SET(LINK_LIBS ${LINK_LIBS} ${LIBRARY})
  ENDIF(${VARIABLE})
ENDMACRO(CHECK_LIBRARY_EXISTS_CONCAT)

CHECK_LIBRARY_EXISTS_CONCAT("m" printf HAVE_LIBM)
CHECK_LIBRARY_EXISTS_CONCAT("ws2_32" printf HAVE_LIBWS2_32)
CHECK_LIBRARY_EXISTS_CONCAT("wsock32" printf HAVE_LIBWSOCK32)
#CHECK_LIBRARY_EXISTS_CONCAT("dl"     dlopen       HAVE_LIBDL)
CHECK_LIBRARY_EXISTS_CONCAT("ucb"    gethostname  HAVE_LIBUCB)
CHECK_LIBRARY_EXISTS_CONCAT("socket" connect      HAVE_LIBSOCKET)
CHECK_LIBRARY_EXISTS("c" gethostbyname "" NOT_NEED_LIBNSL)

IF(NOT NOT_NEED_LIBNSL)
  CHECK_LIBRARY_EXISTS_CONCAT("nsl"    gethostbyname  HAVE_LIBNSL)
ENDIF(NOT NOT_NEED_LIBNSL)


SET(USE_INCLUDES "")
# Check if header file exists and add it to the list.
MACRO(CHECK_INCLUDE_FILE_CONCAT FILE VARIABLE)
  CHECK_INCLUDE_FILES("${USE_INCLUDES};${FILE}" ${VARIABLE})
  IF(${VARIABLE})
    SET(USE_INCLUDES ${USE_INCLUDES} ${FILE})
  ENDIF(${VARIABLE})
ENDMACRO(CHECK_INCLUDE_FILE_CONCAT)

CHECK_INCLUDE_FILE_CONCAT("globus/common.h" HAVE_GLOBUS_COMMON_H)
CHECK_INCLUDE_FILE_CONCAT("io.h" HAVE_IO_H)
CHECK_INCLUDE_FILE_CONCAT("mfhdf.h" HAVE_MFHDF_H)
CHECK_INCLUDE_FILE_CONCAT("pdb.h" HAVE_PDB_H)
CHECK_INCLUDE_FILE_CONCAT("pthread.h" HAVE_PTHREAD_H)
CHECK_INCLUDE_FILE_CONCAT("setjmp.h" HAVE_SETJMP_H)
CHECK_INCLUDE_FILE_CONCAT("srbclient.h" HAVE_SRBCLIENT_H)
CHECK_INCLUDE_FILE_CONCAT("stddef.h" HAVE_STDDEF_H)
CHECK_INCLUDE_FILE_CONCAT("stdint.h" HAVE_STDINT_H)
CHECK_INCLUDE_FILE_CONCAT("string.h" HAVE_STRING_H)
CHECK_INCLUDE_FILE_CONCAT("strings.h" HAVE_STRINGS_H)
CHECK_INCLUDE_FILE_CONCAT("sys/ioctl.h" HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILE_CONCAT("sys/proc.h" HAVE_SYS_PROC_H)
CHECK_INCLUDE_FILE_CONCAT("sys/resource.h" HAVE_SYS_RESOURCE_H)
CHECK_INCLUDE_FILE_CONCAT("sys/socket.h" HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILE_CONCAT("sys/stat.h" HAVE_SYS_STAT_H)
IF(CMAKE_SYSTEM_NAME MATCHES "OSF")
  CHECK_INCLUDE_FILE_CONCAT("sys/sysinfo.h" HAVE_SYS_SYSINFO_H)
ELSE(CMAKE_SYSTEM_NAME MATCHES "OSF")
  SET(HAVE_SYS_SYSINFO_H "" CACHE INTERNAL "" FORCE)
ENDIF(CMAKE_SYSTEM_NAME MATCHES "OSF")
CHECK_INCLUDE_FILE_CONCAT("sys/time.h" HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILE_CONCAT("sys/timeb.h" HAVE_SYS_TIMEB_H)
CHECK_INCLUDE_FILE_CONCAT("sys/types.h" HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE_CONCAT("unistd.h" HAVE_UNISTD_H)
CHECK_INCLUDE_FILE_CONCAT("stdlib.h" HAVE_STDLIB_H)
CHECK_INCLUDE_FILE_CONCAT("memory.h" HAVE_MEMORY_H)
CHECK_INCLUDE_FILE_CONCAT("dlfcn.h" HAVE_DLFCN_H)
CHECK_INCLUDE_FILE_CONCAT("features.h" HAVE_FEATURES_H)
CHECK_INCLUDE_FILE_CONCAT("inttypes.h" HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE_CONCAT("winsock.h" HAVE_WINSOCK_H)

# if the c compiler found stdint, check the C++ as well. On some systems this
# file will be found by C but not C++, only do this test if the C++ compiler
# has been initialized (e.g. the project also includes some c++)
IF (HAVE_STDINT_H AND CMAKE_CXX_COMPILER_LOADED)
  CHECK_INCLUDE_FILE_CXX("stdint.h" HAVE_STDINT_H_CXX)
  IF (NOT HAVE_STDINT_H_CXX)
    SET (HAVE_STDINT_H "" CACHE INTERNAL "Have includes HAVE_STDINT_H")
  ENDIF (NOT HAVE_STDINT_H_CXX)
ENDIF (HAVE_STDINT_H AND CMAKE_CXX_COMPILER_LOADED)

IF(HDF5_ZLIB_INCLUDE_DIRS OR VTK_ZLIB_LIBRARIES)
  SET(HAVE_ZLIB_H 1)
ELSE(HDF5_ZLIB_INCLUDE_DIRS OR VTK_ZLIB_LIBRARIES)
  CHECK_INCLUDE_FILE_CONCAT("zlib.h" HAVE_ZLIB_H)
ENDIF(HDF5_ZLIB_INCLUDE_DIRS OR VTK_ZLIB_LIBRARIES)

CHECK_TYPE_SIZE(char           SIZEOF_CHAR)
CHECK_TYPE_SIZE(short          SIZEOF_SHORT)
CHECK_TYPE_SIZE(int            SIZEOF_INT)
CHECK_TYPE_SIZE(long           SIZEOF_LONG)
CHECK_TYPE_SIZE(float          SIZEOF_FLOAT)
CHECK_TYPE_SIZE(double         SIZEOF_DOUBLE)
CHECK_TYPE_SIZE("long double"  SIZEOF_LONG_DOUBLE)
CHECK_TYPE_SIZE(int8_t         SIZEOF_INT8_T)
CHECK_TYPE_SIZE(uint8_t        SIZEOF_UINT8_T)
CHECK_TYPE_SIZE(int_least8_t   SIZEOF_INT_LEAST8_T)
CHECK_TYPE_SIZE(uint_least8_t  SIZEOF_UINT_LEAST8_T)
CHECK_TYPE_SIZE(int_fast8_t    SIZEOF_INT_FAST8_T)
CHECK_TYPE_SIZE(uint_fast8_t   SIZEOF_UINT_FAST8_T)
CHECK_TYPE_SIZE(int16_t        SIZEOF_INT16_T)
CHECK_TYPE_SIZE(uint16_t       SIZEOF_UINT16_T)
CHECK_TYPE_SIZE(int_least16_t  SIZEOF_INT_LEAST16_T)
CHECK_TYPE_SIZE(uint_least16_t SIZEOF_UINT_LEAST16_T)
CHECK_TYPE_SIZE(int_fast16_t   SIZEOF_INT_FAST16_T)
CHECK_TYPE_SIZE(uint_fast16_t  SIZEOF_UINT_FAST16_T)
CHECK_TYPE_SIZE(int32_t        SIZEOF_INT32_T)
CHECK_TYPE_SIZE(uint32_t       SIZEOF_UINT32_T)
CHECK_TYPE_SIZE(int_least32_t  SIZEOF_INT_LEAST32_T)
CHECK_TYPE_SIZE(uint_least32_t SIZEOF_UINT_LEAST32_T)
CHECK_TYPE_SIZE(int_fast32_t   SIZEOF_INT_FAST32_T)
CHECK_TYPE_SIZE(uint_fast32_t  SIZEOF_UINT_FAST32_T)
CHECK_TYPE_SIZE(int64_t        SIZEOF_INT64_T)
CHECK_TYPE_SIZE(uint64_t       SIZEOF_UINT64_T)
CHECK_TYPE_SIZE(jdshkjfhdks    SIZEOF_JDSHKJFHDKS)
CHECK_TYPE_SIZE(int_least64_t  SIZEOF_INT_LEAST64_T)
CHECK_TYPE_SIZE(uint_least64_t SIZEOF_UINT_LEAST64_T)
CHECK_TYPE_SIZE(int_fast64_t   SIZEOF_INT_FAST64_T)
CHECK_TYPE_SIZE(uint_fast64_t  SIZEOF_UINT_FAST64_T)
CHECK_TYPE_SIZE(size_t         SIZEOF_SIZE_T)
CHECK_TYPE_SIZE(ssize_t        SIZEOF_SSIZE_T)
CHECK_TYPE_SIZE(off_t          SIZEOF_OFF_T)
CHECK_TYPE_SIZE(__int64        SIZEOF___INT64)
CHECK_TYPE_SIZE("long long"    SIZEOF_LONG_LONG)

# For other tests to use the same libraries
SET(CMAKE_REQUIRED_LIBRARIES ${LINK_LIBS})

# Check for some functions that are used
CHECK_FUNCTION_EXISTS(strdup            HAVE_STRDUP)
CHECK_FUNCTION_EXISTS(snprintf          HAVE_SNPRINTF)
CHECK_FUNCTION_EXISTS(system            HAVE_SYSTEM)
CHECK_FUNCTION_EXISTS(vsnprintf         HAVE_VSNPRINTF)
CHECK_FUNCTION_EXISTS(waitpid           HAVE_WAITPID)
CHECK_FUNCTION_EXISTS(signal            HAVE_SIGNAL)
CHECK_FUNCTION_EXISTS(ioctl             HAVE_IOCTL)
CHECK_FUNCTION_EXISTS(sigaction         HAVE_SIGACTION)
CHECK_FUNCTION_EXISTS(getpwuid          HAVE_GETPWUID)
CHECK_FUNCTION_EXISTS(getrusage         HAVE_GETRUSAGE)
CHECK_FUNCTION_EXISTS(gettimeofday      HAVE_GETTIMEOFDAY)
CHECK_FUNCTION_EXISTS(longjmp           HAVE_LONGJMP)
CHECK_FUNCTION_EXISTS(fork              HAVE_FORK)
CHECK_FUNCTION_EXISTS(difftime          HAVE_DIFFTIME)
CHECK_FUNCTION_EXISTS(gethostname       HAVE_GETHOSTNAME)
CHECK_FUNCTION_EXISTS(sigaction         HAVE_SIGACTION)
CHECK_FUNCTION_EXISTS(frexpf            HAVE_FREXPF)
CHECK_FUNCTION_EXISTS(frexpl            HAVE_FREXPL)

CHECK_SYMBOL_EXISTS(TIOCGWINSZ "sys/ioctl.h" HAVE_TIOCGWINSZ)
CHECK_SYMBOL_EXISTS(TIOCGETD   "sys/ioctl.h" HAVE_TIOCGETD)
# e.g. IBM BlueGene/L doesn't have SO_REUSEADDR, because "setsockopt is not needed for
# BlueGene/L applications" according to the BlueGene/L Application Development handbook
CHECK_SYMBOL_EXISTS(SO_REUSEADDR "sys/types.h;sys/socket.h" HAVE_SO_REUSEADDR)

IF(HDF5_STREAM_VFD)
  CHECK_INCLUDE_FILE_CONCAT("netdb.h" HAVE_NETDB_H)
  CHECK_INCLUDE_FILE_CONCAT("netinet/tcp.h" HAVE_NETINET_TCP_H)
  CHECK_INCLUDE_FILE_CONCAT("sys/filio.h" HAVE_SYS_FILIO_H)
  SET(H5_HAVE_STREAM 1)
ENDIF(HDF5_STREAM_VFD)

# Cray Xt3/Catamount doesn't support IP networking
IF(CMAKE_SYSTEM MATCHES Catamount)
  SET(H5_HAVE_STREAM 0)
ENDIF(CMAKE_SYSTEM MATCHES Catamount)


# For other other specific tests, use this macro.
MACRO(OTHER_INTERNAL_TEST OTHER_TEST)
  IF("${OTHER_TEST}" MATCHES "^${OTHER_TEST}$")
    SET(MACRO_CHECK_FUNCTION_DEFINITIONS
      "-D${OTHER_TEST} ${CMAKE_REQUIRED_FLAGS}")
    SET(OTHER_TEST_ADD_LIBRARIES)
    IF(CMAKE_REQUIRED_LIBRARIES)
      SET(OTHER_TEST_ADD_LIBRARIES
        "-DLINK_LIBRARIES:STRING=${CMAKE_REQUIRED_LIBRARIES}")
    ENDIF(CMAKE_REQUIRED_LIBRARIES)
    FOREACH(def ${HDF5_EXTRA_TEST_DEFINITIONS})
      SET(MACRO_CHECK_FUNCTION_DEFINITIONS
        "${MACRO_CHECK_FUNCTION_DEFINITIONS} -D${def}=${${def}}")
    ENDFOREACH(def)

    FOREACH(def
        HAVE_SYS_TIME_H
        HAVE_UNISTD_H
        HAVE_SYS_TYPES_H
        HAVE_SYS_SOCKET_H)
      IF("${def}")
        SET(MACRO_CHECK_FUNCTION_DEFINITIONS
          "${MACRO_CHECK_FUNCTION_DEFINITIONS} -D${def}")
      ENDIF("${def}")
    ENDFOREACH(def)
    IF(LINUX_LFS)
    #don't be tempted to put this all in one multiline string macro will fail
      SET(MACRO_CHECK_FUNCTION_DEFINITIONS
        "${MACRO_CHECK_FUNCTION_DEFINITIONS} -D_FILE_OFFSET_BITS=64")
      SET(MACRO_CHECK_FUNCTION_DEFINITIONS
