=== debian/changelog ===
xdmf (3.0+git20160803-1build1) zesty; urgency=medium

  * Rebuild against new hdf5

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 29 Nov 2016 17:37:13 +0000
